/* Screen Transitions
	Shadowdarke (shadowdarke@hotmail.com) Jan 2007

	This library provides two very simple procs to display fade effects and several demo fade icons.

	See screen_transition_demo.dm for a demonstration of usage.
*/

client
	proc
		st_fadeout(Icon, frames, Layer = 50)
		/* fade out using Icon for frames number of frames
			RETURNS: the HUD obj used to obscure the screen
		*/
			var/obj/fade = new()
			fade.text = " "
			fade.name = ""
			fade.icon = Icon
			fade.icon_state = "1"
			fade.layer = Layer
			fade.screen_loc = "SOUTHWEST to NORTHEAST"
			screen += fade
			for(var/frame = 2 to frames)
				sleep(1)
				fade.icon_state = "[frame]"
			return fade

		st_fadein(obj/fade)
		// fade back in using the existing fade obj
			if(!fade) return
			spawn()	/* return right away so that the program thread may finish and the player can move right
						away, even as the fade effect continues until it's gone. */
				var/frames = text2num(fade.icon_state)
				for(var/frame = frames-1 to 1 step -1)
					fade.icon_state = "[frame]"
					sleep(1)
				screen -= fade
				del(fade)